"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var yogaHandler_1 = require("./yogaHandler");
var $yogaRoot = new rxjs_1.Subject();
exports.$updatedYogaCoords = new rxjs_1.Subject();
$yogaRoot
    .pipe(operators_1.debounceTime(100), operators_1.map(function (instance) {
    return new rxjs_1.Observable(function (subscriber) {
        var handleYogaProps = function (newProps, instance) {
            var yogaChildren = newProps.children, yogaPropsWithoutChildren = __rest(newProps, ["children"]);
            if (instance.parent && instance.parent.type === 'GROUP') {
                yogaPropsWithoutChildren.x += instance.parent.x;
                yogaPropsWithoutChildren.y += instance.parent.y;
            }
            subscriber.next({ instance: instance, props: yogaPropsWithoutChildren });
            if (instance.children) {
                instance.children.forEach(function (child, index) {
                    handleYogaProps(newProps.children[index], child);
                });
            }
        };
        yogaHandler_1.yogaHandler(instance).then(function (newProps) {
            handleYogaProps(newProps, instance);
            subscriber.complete();
        });
    });
}), operators_1.concatAll())
    .subscribe(exports.$updatedYogaCoords);
exports.updateYogaRoot = function (root) {
    $yogaRoot.next(root);
};
//# sourceMappingURL=yogaStream.js.map